
@#define dig_curr = 1
@#define show_ss = 0


var 
Y Ym K L I C G Qk PI PIo RHO LAM Rk R N Ne Nn NU ETA PHI Z X Pm U MU D F H Rn DEL 
In EXA EXK EXG dep cash 


@#if dig_curr
    dc Rdc 
@#endif


Rd gamd sdlag1 SC SPR dSPR Xd recur_welfare
;
 
varexo 
e_a  e_k  e_g  e_n  e_i                    
;

parameters  
bet sig hab fri zet tet alf gov acI eps gam kpP kpY kap

// exogenous-process parameters

rho_a rho_i rho_k rho_g rho_p sig_a sig_i sig_k sig_g sig_p sig_n
// steady states 

LSS GSS FSS ISS DELSS SPRSS

// New params
iota RSS RDSS psi_m thet_d rhos epsd omg_d omg_m mu_d  curlm KSS
YSS chiSS

@#if dig_curr
delta_dc
chi_dc 
@#endif
;
 

bet = 0.99;
sig = 1;
hab = 0.815;
fri = 0.276;
zet = 7.2;
tet = 0.97155955;
alf = 0.33;
gov = 0.2;
acI = 1.728;
eps = 4.167;
gam = 0.779;
kpP = 1.5;
kpY = -0.125;
kap = 10;
rho_i = 0.9;   	
sig_i = 0.01;
rho_k = 0.66;	
sig_k = 0.05;
rho_a = 0.95;	
sig_a = 0.01;
rho_g = 0.95;  
sig_g = 0.01;
rho_p = 0.66;	
sig_p = 0.072;
sig_n = 0.01;	

GSS = 0.16975710;	
LSS = 0.33333333; 	
FSS = 4;          	
ISS = 0.14153927; 	
DELSS = 0.025;    
SPRSS = 0.01/4;   
iota = 0.2793;
psi_m = 0.02; 
thet_d = 0.3; 
rhos = 0.75;
RSS = 1/bet;

@#if dig_curr
delta_dc = 0.0025;
chi_dc = 0.016;
@#endif

omg_d = 1;
omg_m = 0.07;

mu_d = 1/0.85; 
RDSS= (RSS- (1-mu_d))/mu_d; 
curlm = (1-thet_d)/(1-thet_d*(1-rhos)*bet);
epsd = 1/(curlm*(1-mu_d));

KSS   = (alf*((eps-1)/eps)/(RSS+SPRSS-1+DELSS))^(1/(1-alf))*LSS;
YSS   = (KSS^alf)*(LSS^(1-alf));
chiSS   = ((1-bet*hab)*((1-hab)*(YSS-DELSS*KSS-gov*YSS))^(-sig))*((eps-1)/eps)*(1-alf)*YSS/(LSS^(1+fri));


%--------------------------------------------------------------------------------------------------------------%
model;
#utc     = alf*((eps-1)/eps)*(YSS/KSS);
#del   = DELSS - utc/(1+zet);
#omg   = (1-tet*(SPRSS*FSS + RSS))*KSS/FSS/KSS;
#ZSS = SPRSS*FSS + RSS;
#ETASS = (1-tet)*bet*RSS/(1-tet*bet*ZSS);
#NUSS  = (1-tet)*bet*SPRSS/(1-bet*tet*ZSS);
#lam   = NUSS + ETASS/FSS;
#CSS =YSS-DELSS*KSS-gov*YSS;
#RHOSS = (1-bet*hab)*((1-hab)*CSS)^(-sig);  
#chi   = RHOSS*((eps-1)/eps)*(1-alf)*YSS/(LSS^(1+fri));

%--------------------------------------------------------------------------------------------------------------%
exp(RHO) =  (exp(C)-hab*exp(C(-1)))^(-sig) - bet*hab*(exp(C(+1))-hab*exp(C))^(-sig);
exp(RHO) - bet*exp(RHO(+1))*exp(Rd)/exp(PI(+1))  = omg_d*exp(Xd)^(-iota);
exp(dep) = exp(Xd) + thet_d*exp(sdlag1);
exp(RHO)*(1 + (psi_m/2)*(exp(cash)*exp(PI)/exp(cash(-1))-1)^2 
+ psi_m*exp(PI)*(exp(cash)/exp(cash(-1)))*(exp(cash)*exp(PI)/exp(cash(-1))-1)) 
- bet*exp(RHO(+1))*(1/exp(PI(+1)) + psi_m*exp(PI(+1))*(exp(cash(+1))*
exp(PI(+1))/exp(cash) -1)*(exp(cash(+1))/exp(cash))^2) = omg_m*exp(cash)^(-iota);


@#if dig_curr
exp(RHO) - bet*exp(RHO(+1))*exp(Rdc)/exp(PI(+1))  = exp(dc)^(-iota) ;
@#endif

exp(LAM) = exp(RHO)/exp(RHO(-1));
chi*exp(L)^fri =  exp(RHO)*exp(Pm)*(1-alf)*exp(Y)/exp(L);
exp(NU) = (1-tet)*bet*exp(LAM(+1))*(exp(Rk(+1))-exp(R))+bet*exp(LAM(+1))*tet*exp(X(+1))*exp(NU(+1));
exp(ETA) =  bet*exp(LAM(+1))*( (1-tet)*exp(R) + tet*exp(Z(+1))*exp(ETA(+1)) );
exp(PHI) = exp(ETA)/(lam-exp(NU));
exp(Z) = (exp(Rk)-exp(R(-1)))*exp(PHI(-1)) + exp(R(-1));
exp(X) = exp(PHI)/exp(PHI(-1))*exp(Z);
exp(Qk)*exp(K) = exp(PHI)*exp(N);
exp(N) = exp(Ne) + exp(Nn);
exp(Ne) = tet*exp(Z)*exp(N(-1))*exp(-sig_n*e_n);
exp(Nn) = omg*exp(Qk)*exp(EXK)*exp(K(-1)); 
exp(dep) = exp(Qk)*exp(K) - exp(N) ;
exp(R) - exp(Rd) = ((exp(Rd)-1)/epsd)*(exp(gamd)/(thet_d-exp(gamd))) 
                            - thet_d*(1-rhos)*bet*exp(LAM(+1))*((exp(Rd(+1))-1)/epsd)*(exp(gamd(+1))
                            /(thet_d-exp(gamd(+1))));
exp(gamd) = exp(dep)/exp(sdlag1);
exp(sdlag1) = rhos*exp(sdlag1(-1)) + (1-rhos)*exp(dep(-1));
exp(Rk) =  (exp(Pm)*alf*exp(Ym)/exp(K(-1))+exp(EXK)*(exp(Qk)-exp(DEL)))/exp(Qk(-1));
exp(Ym) = exp(EXA)*(exp(EXK)*exp(U)*exp(K(-1)))^alf*exp(L)^(1-alf);
exp(Qk) = 1 + acI/2*((In+ISS)/(In(-1)+ISS)-1)^2+acI*((In+ISS)/(In(-1)+ISS)-1)*(In+ISS)/(In(-1)+ISS)-bet*exp(LAM(+1))*acI*((In(+1)+ISS)/(In+ISS)-1)*((In(+1)+ISS)/(In+ISS))^2;
exp(DEL) = del + utc/(1+zet)*exp(U)^(1+zet);
exp(Pm)*alf*exp(Ym)/exp(U) = utc*exp(U)^zet*exp(EXK)*exp(K(-1));
In = exp(I) - exp(DEL)*exp(EXK)*exp(K(-1));
exp(K) = exp(EXK)*exp(K(-1)) + In;
exp(G) = gov*exp(Y)*exp(EXG);
@#if dig_curr
    exp(Y) = exp(C)+exp(G)+exp(I)+acI/2*((In+ISS)/(In(-1)+ISS)-1)^2*(In+ISS) + chi_dc*exp(dc); %+ chi_dc*(exp(dc)^2)/2;
@#else 
    exp(Y) = exp(C)+exp(G)+exp(I)+acI/2*((In+ISS)/(In(-1)+ISS)-1)^2*(In+ISS); 
@#endif
exp(Ym) = exp(Y)*exp(D) ;
exp(D) = gam*exp(D(-1))*exp(PI(-1))^(-kap*eps)*exp(PI)^eps+(1-gam)*((1-gam*exp(PI(-1))
                ^(kap*(1-gam))*exp(PI)^(gam-1))/(1-gam))^(-eps/(1-gam));
exp(MU) = 1/exp(Pm);
exp(F) =  exp(Y)*exp(Pm)+bet*gam*exp(LAM(+1))*exp(PI(+1))^eps*(exp(PI))^(-eps*kap)*exp(F(+1));
exp(H) = exp(Y)+bet*gam*exp(LAM(+1))*exp(PI(+1))^(eps-1)*exp(PI)^(kap*(1-eps))*exp(H(+1));
exp(PIo) = eps/(eps-1)*exp(F)/exp(H)*exp(PI);
(exp(PI))^(1-eps) = gam*exp(PI(-1))^(kap*(1-eps))+(1-gam)*(exp(PIo))^(1-eps);
exp(Rn) = exp(R)*exp(PI(+1));
exp(Rn) = exp(Rn(-1))^rho_i*((RSS)*exp(PI)^kpP*(exp(MU)/(eps/(eps-1)))^(kpY))^(1-rho_i)*exp(sig_i*e_i);

@#if dig_curr
exp(Rdc) = exp(Rn) + delta_dc;
@#endif
EXA = rho_a*EXA(-1) - sig_a*e_a;
EXK = rho_k*EXK(-1) - sig_k*e_k;
EXG = rho_g*EXG(-1) - sig_g*e_g;
exp(SPR) = exp(Rk(+1))/exp(R);
exp(SC) = thet_d*exp(sdlag1)*exp(Rd);
exp(dSPR) = exp(R)/exp(Rd);

% Recursive welfare


@#if dig_curr 
    recur_welfare = log(exp(C)-hab*exp(C(-1)))
                        - chi*exp(L)^(1+fri)/(1+fri)
                        + (1/(1-iota))*(omg_m*exp(cash)^(1-iota) 
                        + omg_d*exp(Xd)^(1-iota)  
                        + exp(dc)^(1-iota)) 
                        + bet*recur_welfare(+1);
 @#else
    recur_welfare = log(exp(C)-hab*exp(C(-1)))
                        - chi*exp(L)^(1+fri)/(1+fri)
                        + (1/(1-iota))*(omg_m*exp(cash)^(1-iota) 
                        + omg_d*exp(Xd)^(1-iota)) 
                        + bet*recur_welfare(+1);
@#endif
end;


%--------------------------------------------------------------------%
% options_.TeX=1;            
% collect_latex_files
%--------------------------------------------------------------------%

initval; % all not mentioned are zero
Y       = -0.163949;
Ym      = -0.163949;
K       =  1.7337;
L       = -1.09861;
I       = -1.95518;
%C       =  -0.620847;
G       = -1.77339;
RHO     =  0.663958;
Rk      =  0.0125223;
R       =  0.0100503;
N       =  0.347407;
Ne      =  0.338456;
Nn      = -4.37305;
NU      = -5.58873;
ETA     =  0.412785;
PHI     =  1.38629;
Z       =  0.0199017;
X       =  0.0199017;
Pm      = -0.274412;
MU      =  0.274412;
F       =  1.03659;
H       =  1.311;
Rn      =  0.0100503;
DEL     = -3.68888;
SPR     =  0.00247194;
dep     =  1.44602;
Xd = log((1-thet_d)*exp(dep));
cash    =  0.976147;

@#if dig_curr
    dc      = -1.77339;
    Rdc      =  0.0076; %-1.07635; 
@#endif

Rd        =  0.00854921;
sdlag1  =  1.44602;
SC        = -0.154869;
dSPR    =  0.00150113;
%C = log(exp(Y)-exp(I)-exp(G)- chi_dc*(exp(dc)^2)/2);

@#if dig_curr 
    C = log(exp(Y)-exp(I)-exp(G)- chi_dc*exp(dc));
    recur_welfare = (log(exp(C)-hab*exp(C))
                        - chiSS*exp(L)^(1+fri)/(1+fri)
                        + (1/(1-iota))*( omg_m*exp(cash)^(1-iota) 
                        + omg_d*exp(Xd)^(1-iota)  
                        + exp(dc)^(1-iota) ) )/(1-bet);
@#else
    C = log(exp(Y)-exp(I)-exp(G));
    recur_welfare = (log(exp(C)-hab*exp(C))
                        - chiSS*exp(L)^(1+fri)/(1+fri)
                        + (1/(1-iota))*( omg_m*exp(cash)^(1-iota) 
                        + omg_d*exp(Xd)^(1-iota)))/(1-bet);
@#endif


end;


// SIMULATION.

resid;
%steady(solve_algo=0,maxit=5000);

//// COMPUTE THE SS /////
steady(solve_algo=3);
check;

model_diagnostics;
options_.pruning        = 1;
options_.relative_irf   = 1;
options_.nocorr         = 1;
options_.nomoments      = 1;
options_.noprint        = 1;
options_.nograph        = 0;
options_.simul_seed     = 42;

% 
% options_.TeX=1;            
% collect_latex_files;

shocks;
var e_a = 1;
var e_k = 1; 
var e_g = 1; 
var e_n = 1; 
var e_i = 1;
end;


stoch_simul(order=2, irf=40,nograph) ;
%------------------------------------------------------%
% write_latex_dynamic_model;
% write_latex_parameter_table;
% collect_latex_files;
%------------------------------------------------------%

@#if show_ss 
ss_vector = oo_.steady_state;
var_names = M_.endo_names;
n_vars = length(var_names);  
variables = struct();
for i = 1:n_vars
    field_name = matlab.lang.makeValidName(var_names{i});
    variables.(field_name) = double(ss_vector(i));
end

disp(' ');disp('%%% Display some SS results: %%%%')

%Macro
%disp(['C/Y= ', num2str(variables.C / variables.Y)]);
disp(['D/K= ', num2str(exp(variables.dep )/ exp(variables.K))]);
disp(['M/Y= ', num2str(exp(variables.cash) / exp(variables.Y))]);
disp(['In/Y= ', num2str(exp(variables.In) / exp(variables.Y))]);
@#endif 